# TPK4186 - Advanced Tools for Performance Engineering
# LanguagePopularity.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

import matplotlib.pyplot as plt

# Data to plot
languages = ['Java', 'C', 'Python', 'C++', 'C#', 'Visual Basic', 'JavaScript', 'PHP', 'Objective-C', 'SQL']
popularity = [16.028, 15.154, 10.020, 6.057, 3.842, 3.695, 2.258, 2.075, 1.690, 1.625]

sum = 0.0
for value in popularity:
  sum += value
languages.append('Others')
popularity.append(100 - sum)

colors = ["blue", "orange", "green", "red", "purple", "brown", "pink", "gray", "cyan", "olive", "lavender"]
# explode 1st slice
# explode = (0.1, 0, 0, 0,0,0)  
# Plot
plt.pie(popularity, labels=languages, colors=colors, autopct='%1.1f%%', shadow=True, startangle=140)
plt.savefig('LanguagePopularity.pdf')  
plt.axis('equal')
plt.show()