# TPK4186 - Advanced Tools for Performance Engineering
# MP3Player.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.


import pygame
# Not all versions of pygame are compatible with Python 3.7
# I installed one which is, by means of the command:
# conda install -c delichon pygame

def StartPygame():
  pygame.init()
  pygame.display.set_mode((200,100))

def QuitPygame():
  pygame.display.quit()
  pygame.quit()

def PlayFile(fileName):
  try:
    pygame.mixer.init()
    pygame.mixer.music.set_volume(0.5)
    pygame.mixer.music.load(fileName)
    pygame.mixer.music.play()
    clock = pygame.time.Clock()
    clock.tick(10)
    while pygame.mixer.music.get_busy():
      for event in pygame.event.get():
        if event.type == pygame.QUIT:
          StopPlaying()
      clock.tick(10)
  except:
    StopPlaying()

def StopPlaying():
  pygame.mixer.music.stop()

fileName = "Songs/Joan Baez - Diamonds and Rust.mp3"
StartPygame()
PlayFile(fileName)
QuitPygame()

