# TPK4186 - Advanced Tools for Performance Engineering
# MatrixEquation3.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Required modules
import sys
import math
from Matrices import *

# Definition of matrices A, B and C
A = [
  [2, 4],
  [3, 2]]
B = [
  [1, 0],
  [2, 1]]
C = [
  [7, 5],
  [6, 1]]

print("A =")
MatrixPrint(A)
print("")

print("B =")
MatrixPrint(B)
print("")

print("C =")
MatrixPrint(C)
print("")

# Calculation of matrix X
AT = MatrixTranspose(A)
ATI = MatrixInverse(AT)
BI = MatrixInverse(B)
Y = MatrixProduct(ATI, C)
X = MatrixProduct(Y, BI)

print("X =")
MatrixPrint(X)
print("")

