# TPK4186 - Advanced Tools for Performance Engineering
# ShellingMap.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

import matplotlib.pyplot as plt
from matplotlib import colors
import numpy as np

numberOfRows = 100
numberOfColumns = 100

shellingMap = np.random.rand(numberOfRows, numberOfColumns)

# create discrete colormap
cmap = colors.ListedColormap(['blue', 'white', 'red'])
bounds = [0, 0.45, 0.55, 1.0]
norm = colors.BoundaryNorm(bounds, cmap.N)

fig, ax = plt.subplots()
ax.imshow(shellingMap, cmap=cmap, norm=norm, aspect='equal')

# draw gridlines
plt.axis('off')
plt.savefig('ShellingMap.pdf')  

