# TPK4186 - Advanced Tools for Performance Engineering
# Main.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Table of contents
# -----------------
# 1. Required modules
# 2. Loading the cohort
# 3. Queries

# 1. Required modules
# -------------------

import sys
import math
from StudentCohort import *

# 2. Loading the cohort
# -----------------------

def CohortCreator():
  cohort = Cohort_New()
  student = Cohort_NewStudent(cohort, 2961201002)
  Student_SetFamilyName(student, "Smith")
  Student_SetFirstName(student, "Alice")
  Student_SetGender(student, "Female")
  Student_SetDateOfBirth(student, 1, 12, 1996)
  Student_SetEmailAddress(student, "alice.smith@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "MEC4131")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "MAT4260")
  Student_Register(student, "MNG4255")

  student = Cohort_NewStudent(cohort, 1970706004)
  Student_SetFamilyName(student, "Johnson")
  Student_SetFirstName(student, "Bob")
  Student_SetGender(student, "Male")
  Student_SetDateOfBirth(student, 6, 7, 1997)
  Student_SetEmailAddress(student, "bob.johnson@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "PYS4160")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "PHI4203")
  Student_Register(student, "MNG4255")

  student = Cohort_NewStudent(cohort, 2960921005)
  Student_SetFamilyName(student, "Williams")
  Student_SetFirstName(student, "Carol")
  Student_SetGender(student, "Female")
  Student_SetDateOfBirth(student, 21, 9, 1996)
  Student_SetEmailAddress(student, "carol.williams@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "PYS4160")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "ECO4215")
  Student_Register(student, "PHI4203")

  student = Cohort_NewStudent(cohort, 1970217008)
  Student_SetFamilyName(student, "Jones")
  Student_SetFirstName(student, "David")
  Student_SetGender(student, "Male")
  Student_SetDateOfBirth(student, 17, 2, 1997)
  Student_SetEmailAddress(student, "david.jones@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "MEC4131")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "PYS4265")
  Student_Register(student, "INF4261")

  student = Cohort_NewStudent(cohort, 2950307011)
  Student_SetFamilyName(student, "Brown")
  Student_SetFirstName(student, "Eve")
  Student_SetGender(student, "Female")
  Student_SetDateOfBirth(student, 7, 3, 1995)
  Student_SetEmailAddress(student, "eve.brown@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "PYS4160")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "MAT4260")
  Student_Register(student, "MNG4255")

  student = Cohort_NewStudent(cohort, 1960115013)
  Student_SetFamilyName(student, "Davis")
  Student_SetFirstName(student, "Frank")
  Student_SetGender(student, "Male")
  Student_SetDateOfBirth(student, 15, 1, 1996)
  Student_SetEmailAddress(student, "frank.davis@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "PYS4160")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "PYS4265")
  Student_Register(student, "PHI4203")

  student = Cohort_NewStudent(cohort, 2970701014)
  Student_SetFamilyName(student, "Miller")
  Student_SetFirstName(student, "Grace")
  Student_SetGender(student, "Female")
  Student_SetDateOfBirth(student, 1, 7, 1997)
  Student_SetEmailAddress(student, "grace.miller@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "PYS4160")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "PHI4203")
  Student_Register(student, "PYS4265")

  student = Cohort_NewStudent(cohort, 2950504017)
  Student_SetFamilyName(student, "Wilson")
  Student_SetFirstName(student, "Heidi")
  Student_SetGender(student, "Female")
  Student_SetDateOfBirth(student, 4, 5, 1995)
  Student_SetEmailAddress(student, "heidi.wilson@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "MEC4131")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "MAT4240")
  Student_Register(student, "PHI4203")

  student = Cohort_NewStudent(cohort, 1970324019)
  Student_SetFamilyName(student, "Hall")
  Student_SetFirstName(student, "Ivan")
  Student_SetGender(student, "Male")
  Student_SetDateOfBirth(student, 24, 3, 1997)
  Student_SetEmailAddress(student, "ivan.hall@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "PYS4160")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "PYS4265")
  Student_Register(student, "INF4261")

  student = Cohort_NewStudent(cohort, 2970626020)
  Student_SetFamilyName(student, "Allen")
  Student_SetFirstName(student, "Joan")
  Student_SetGender(student, "Female")
  Student_SetDateOfBirth(student, 26, 6, 1997)
  Student_SetEmailAddress(student, "joan.allen@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "PYS4160")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "MAT4240")
  Student_Register(student, "PYS4265")

  student = Cohort_NewStudent(cohort, 1951226023)
  Student_SetFamilyName(student, "Young")
  Student_SetFirstName(student, "Michael")
  Student_SetGender(student, "Male")
  Student_SetDateOfBirth(student, 26, 12, 1995)
  Student_SetEmailAddress(student, "michael.young@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "PYS4160")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "ECO4215")
  Student_Register(student, "INF4261")

  student = Cohort_NewStudent(cohort, 2960930024)
  Student_SetFamilyName(student, "Hernandez")
  Student_SetFirstName(student, "Nicole")
  Student_SetGender(student, "Female")
  Student_SetDateOfBirth(student, 30, 9, 1996)
  Student_SetEmailAddress(student, "nicole.hernandez@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "PYS4160")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "MAT4260")
  Student_Register(student, "MNG4255")

  student = Cohort_NewStudent(cohort, 1950331025)
  Student_SetFamilyName(student, "King")
  Student_SetFirstName(student, "Oscar")
  Student_SetGender(student, "Male")
  Student_SetDateOfBirth(student, 31, 3, 1995)
  Student_SetEmailAddress(student, "oscar.king@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "MEC4131")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "PYS4265")
  Student_Register(student, "ECO4215")

  student = Cohort_NewStudent(cohort, 2950711026)
  Student_SetFamilyName(student, "Wright")
  Student_SetFirstName(student, "Peggy")
  Student_SetGender(student, "Female")
  Student_SetDateOfBirth(student, 11, 7, 1995)
  Student_SetEmailAddress(student, "peggy.wright@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "PYS4160")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "MAT4240")
  Student_Register(student, "PHI4203")

  student = Cohort_NewStudent(cohort, 1960213027)
  Student_SetFamilyName(student, "Smith ")
  Student_SetFirstName(student, "Ruppert")
  Student_SetGender(student, "Male")
  Student_SetDateOfBirth(student, 13, 2, 1996)
  Student_SetEmailAddress(student, "ruppert.smith @ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "PYS4160")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "PHI4203")
  Student_Register(student, "INF4261")

  student = Cohort_NewStudent(cohort, 2960422030)
  Student_SetFamilyName(student, "Brown")
  Student_SetFirstName(student, "Sybil")
  Student_SetGender(student, "Female")
  Student_SetDateOfBirth(student, 22, 4, 1996)
  Student_SetEmailAddress(student, "sybil.brown@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "PYS4160")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "MNG4255")
  Student_Register(student, "INF4261")

  student = Cohort_NewStudent(cohort, 1950121032)
  Student_SetFamilyName(student, "Johnson")
  Student_SetFirstName(student, "Ted")
  Student_SetGender(student, "Male")
  Student_SetDateOfBirth(student, 21, 1, 1995)
  Student_SetEmailAddress(student, "ted.johnson@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "MEC4131")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "PHI4203")
  Student_Register(student, "PYS4265")

  student = Cohort_NewStudent(cohort, 1960907034)
  Student_SetFamilyName(student, "Sanchez")
  Student_SetFirstName(student, "Victor")
  Student_SetGender(student, "Male")
  Student_SetDateOfBirth(student, 7, 9, 1996)
  Student_SetEmailAddress(student, "victor.sanchez@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "PYS4160")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "PYS4265")
  Student_Register(student, "MAT4260")

  student = Cohort_NewStudent(cohort, 1950806036)
  Student_SetFamilyName(student, "Hernandez")
  Student_SetFirstName(student, "Walter")
  Student_SetGender(student, "Male")
  Student_SetDateOfBirth(student, 6, 8, 1995)
  Student_SetEmailAddress(student, "walter.hernandez@ntnu.no")
  Student_Register(student, "MAT4105")
  Student_Register(student, "PYS4160")
  Student_Register(student, "INF4172")
  Student_Register(student, "INF4223")
  Student_Register(student, "MAT4260")
  Student_Register(student, "ECO4215")

  return cohort

# 3. Queries
# ----------

cohort = CohortCreator()

# Query 0: All students
print("Q0")
students = Cohort_GetStudents(cohort)
PrintStudentList(students)

# Query 1: whose family name is Johnson
print("Q1")
result = Query_Select(students, Student_IsFamilyName, "Johnson")
PrintStudentList(result)

# Query 2: Students born in 1995
print("Q2")
result = Query_Select(students, Student_IsYearOfBirth, 1995)
PrintStudentList(result)

# Query 3: Students registered to PYS4160
print("Q3")
result = Query_Select(students, Student_IsRegistered, "PYS4160")
PrintStudentList(result)

# Query 4: Students registered to both PYS4160 and PYS4265. 
print("Q4")
result = Query_Select(students, Student_IsRegistered, "PYS4160")
result = Query_Select(result, Student_IsRegistered, "PYS4265")
PrintStudentList(result)

# Query 5: Students born in March or in April. 
print("Q5")
result1 = Query_Select(students, Student_IsMonthOfBirth, 3)
result2 = Query_Select(students, Student_IsMonthOfBirth, 4)
result = Query_Union(result1, result2)
PrintStudentList(result)

# Query 6: Students born in 1996 or 1997 who are not taking PYS4160
print("Q6")
result1 = Query_Select(students, Student_IsYearOfBirth, 1996)
result2 = Query_Select(students, Student_IsYearOfBirth, 1997)
result3 = Query_Union(result1, result2)
result4 = Query_Select(students, Student_IsRegistered, "PYS4160")
result = Query_Difference(result3, result4)
PrintStudentList(result)

